; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; TASTE MENUE gedrckt ?	
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MENUE_WERT)
	brne MENUE_RUN
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
	STS(adr_TASTE),NULL	; TASTE clear	
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL,LOW (MENUE_SPRUNGMARKE)
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	add ZL,temp
	adc ZH,NULL
	ijmp ; Sprung nach Z 
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	rjmp MENUE_ANZEIGE
	rjmp MENUE_ANZEIGE_TEMPERATUR
	rjmp MENUE_EDIT_HELLIGKEIT
	rjmp MENUE_EDIT_SCHWELLE_L
	rjmp MENUE_TWI_TAKTFREQUENZ
	rjmp MENUE_RESET ; WERKSEINSTELLUNG	
	; BERLAUF	
	rcall EEPROM_KONFIGURATION_SICHERN	
	rcall ANZEIGE_RUN
MENUE_NEUSTART:
	rjmp MENUE_NEUSTART

;-------------------------------------------------------------------------------
MENUE_ANZEIGE:
	rcall HYT939_MESSUNG
	rcall HYT939_ANZEIGE_RF
	; BLINKEN	
	LDS temp1,(adr_HYT939_RH)
	LDS temp2,(adr_HYT939_RH_SCHWELLE_L)
	cp temp1,temp2
	brsh MENUE_ANZEIGE_OK
	; BLINKEN	
	LDS temp,(adr_HELL_WERT)	
	push temp
	ldi temp,25
	STS(adr_HELL_WERT),temp	
	rcall TASTATUR_WAIT
	pop temp
	STS(adr_HELL_WERT),temp	
	rcall TASTATUR_WAIT
	ret
MENUE_ANZEIGE_OK:
	rcall TASTATUR_WAIT
	rcall TASTATUR_WAIT
	rcall TASTATUR_WAIT
	rcall TASTATUR_WAIT
	rcall TASTATUR_WAIT
	ret
;-------------------------------------------------------------------------------
MENUE_ANZEIGE_TEMPERATUR:
	rcall HYT939_ANZEIGE_TEMPERATUR
	rcall HYT939_MESSUNG
	rcall HYT939_ANZEIGE_TEMPERATUR
	rcall TASTATUR_WAIT
ret
;---------------------------4----------------------------------------------------
MENUE_EDIT_HELLIGKEIT:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_PLUS_WERT)
	breq MENUE_HELLIGKEIT_P
	cpi temp,(TASTE_MINUS_WERT)
	breq MENUE_HELLIGKEIT_M
	rjmp MENUE_HELLIGKEIT_RUN
MENUE_HELLIGKEIT_P:
	LDS temp1,(adr_HELL_WERT)	
	add temp1,EINS
	STS(adr_HELL_WERT),temp1
	rjmp MENUE_HELLIGKEIT_RUN
MENUE_HELLIGKEIT_M:
	LDS temp1,(adr_HELL_WERT)	
	sub temp1,EINS
	STS(adr_HELL_WERT),temp1
	rjmp MENUE_HELLIGKEIT_RUN
MENUE_HELLIGKEIT_RUN:
	; HELLIGKEIT			
	rcall ANZEIGE_HELLIGKEIT
	rcall wait_100ms
	rcall TASTATUR_WAIT
ret
;-------------------------------------------------------------------------------
MENUE_EDIT_SCHWELLE_L:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_PLUS_WERT)
	breq MENUE_EDIT_SCHWELLE_L_P
	cpi temp,(TASTE_MINUS_WERT)
	breq MENUE_EDIT_SCHWELLE_L_M
	rjmp MENUE_EDIT_SCHWELLE_L_RUN
MENUE_EDIT_SCHWELLE_L_P:
	LDS temp1,(adr_HYT939_RH_SCHWELLE_L)	
	add temp1,EINS
	STS(adr_HYT939_RH_SCHWELLE_L),temp1
	rjmp MENUE_EDIT_SCHWELLE_L_RUN
MENUE_EDIT_SCHWELLE_L_M:
	LDS temp1,(adr_HYT939_RH_SCHWELLE_L)	
	sub temp1,EINS
	STS(adr_HYT939_RH_SCHWELLE_L),temp1
	rjmp MENUE_EDIT_SCHWELLE_L_RUN
MENUE_EDIT_SCHWELLE_L_RUN:
	; SCHWELLWWRT_L
	rcall ANZEIGE_SCHWELLE_L
	rcall wait_100ms
	rcall TASTATUR_WAIT
ret
;-------------------------------------------------------------------------------
MENUE_TWI_TAKTFREQUENZ:
	rcall ANZEIGE_TWI_TAKT_FREQUENZ
	rcall wait_100ms
	rcall TASTATUR_WAIT
ret
;-------------------------------------------------------------------------------
MENUE_RESET:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_PLUS_WERT)
	breq MENUE_RESET_PM
	cpi temp,(TASTE_MINUS_WERT)
	breq MENUE_RESET_PM
	rjmp MENUE_RESET_RUN
MENUE_RESET_PM:
	STS(adr_LED_BYTE_0),NULL
	STS(adr_LED_BYTE_1),NULL
	STS(adr_LED_BYTE_2),NULL
	STS(adr_LED_BYTE_3),NULL
	rcall wait_100ms
	ldi temp,0b10000000
	STS(adr_LED_BYTE_0),temp
	rcall wait_100ms
	STS(adr_LED_BYTE_1),temp
	rcall wait_100ms
	STS(adr_LED_BYTE_2),temp
	rcall wait_100ms
	STS(adr_LED_BYTE_3),temp
	rcall wait_100ms
	; HELLIGKEIT		
	ldi temp,4
	STS(adr_HELL_WERT),temp
	; SCHWELLWERT_L		
	ldi temp,40	; 40%
	STS(adr_HYT939_RH_SCHWELLE_L),temp
	; SAVE				
	rcall EEPROM_KONFIGURATION_SICHERN	
MENUE_RESET_PM_s:
	rjmp MENUE_RESET_PM_s
MENUE_RESET_RUN:
	rcall ANZEIGE_RESET
	rcall wait_100ms
	rcall wait_100ms
	rcall TASTATUR_WAIT
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
