; ##############################################################################
; ##############################################################################
; ##############################################################################

.equ ADRESSE_HYT939=40

; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_ANZEIGE_RF:
	LDS temp1,(adr_HYT939_RH)
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	ldi temp,0b01011100	; %
	STS(adr_LED_BYTE_0), temp
	ldi temp,0b01100011	; %
	STS(adr_LED_BYTE_1), temp
  	STS(adr_LED_BYTE_2), temp1
  	STS(adr_LED_BYTE_3), temp2
	rcall WAIT_10ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_ANZEIGE_TEMPERATUR:
	LDS temp1,(adr_HYT939_TEMPERATUR_SIGNIERT)
	tst temp1
	brmi HYT939_ANZEIGE_TEMPERATUR_NEGATIV

	LDS temp1,(adr_HYT939_TEMPERATUR_SIGNIERT)
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	ldi temp,(ZEICHEN_C)	; C	
	STS(adr_LED_BYTE_0), temp
	ldi temp,(ZEICHEN_GRD)	; 	
	STS(adr_LED_BYTE_1), temp
  	STS(adr_LED_BYTE_2), temp1
  	STS(adr_LED_BYTE_3), temp2
	rcall WAIT_10ms
	ret
;-------------------------------------------------------------------------------
HYT939_ANZEIGE_TEMPERATUR_NEGATIV:
	LDS temp1,(adr_HYT939_TEMPERATUR_SIGNIERT)
	com temp1
	inc temp1
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	ldi temp,(ZEICHEN_GRD)	; 	
	STS(adr_LED_BYTE_0), temp
  	STS(adr_LED_BYTE_1), temp1
  	STS(adr_LED_BYTE_2), temp2
	ldi temp,(ZEICHEN_MINUS); -	
	STS(adr_LED_BYTE_3), temp
	rcall WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_MESSUNG:
	; PUNKT on									
	LDS temp,(adr_LED_BYTE_0)
	ori temp, 0b10000000	
	STS(adr_LED_BYTE_0),temp
	; MR (Measurement Requests)					
	; Die Messung dauert ca. 50ms				
	ldi temp1,(ADRESSE_HYT939)					; ADRESSE			
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; START-TRANSMITTER	
	rcall TWI_STOP								; STOP				
	; ERRROR ?									
	tst TWI_FEHLER_CODE
	brne HYT939_MESSUNG_ERROR
	rcall WAIT_10ms
	rcall WAIT_10ms
	rcall WAIT_10ms
	rcall WAIT_10ms
	rcall WAIT_10ms
	rcall WAIT_10ms
	; SCHLEIFE (Begrenzung)						
	ldi temp9,50
HYT939_MESSUNG_s:
	; DF (Data Fetch)							
	ldi temp1,(ADRESSE_HYT939)					; ADRESSE			
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; START-RECEIVER	
	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1		; BYTE read			
	STS(adr_HYT939_DATA_MSB),temp1	;
	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1		; BYTE read			
	STS(adr_HYT939_DATA_LSB),temp1	;
	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1		; BYTE read			
	STS(adr_HYT939_TEMPERATUR_DATA_MSB),temp1 ;
	rcall TWI_MASTER_RECEIVER_LAST_BYTE_TEMP1	; LAST BYTE read	
	STS(adr_HYT939_TEMPERATUR_DATA_LSB),temp1 ;
	rcall TWI_STOP								; STOP				
	; ERRROR ?									
	tst TWI_FEHLER_CODE
	brne HYT939_MESSUNG_ERROR
;-------------------------------------------------------------------------------
	; Bit15: CMode Bit / Bit14:Stale Bit abfragen
	LDS temp,(adr_HYT939_DATA_MSB)
	andi temp,0b11000000
	tst temp
	breq HYT939_MESSUNG_OK
	rcall WAIT_10ms
	; SCHLEIFE (Begrenzung)						
	dec temp9
	breq HYT939_MESSUNG_ERROR
	; PUNKT on									
	LDS temp,(adr_LED_BYTE_1)
	ori temp, 0b10000000	
	STS(adr_LED_BYTE_1),temp
	rjmp HYT939_MESSUNG_s
;-------------------------------------------------------------------------------
HYT939_MESSUNG_OK:
	; Temperatur-DATA 2 x rechts				
	LDS temp1,(adr_HYT939_TEMPERATUR_DATA_LSB)
	LDS temp2,(adr_HYT939_TEMPERATUR_DATA_MSB)
	LSR temp2
	ROR temp1
	LSR temp2
	ROR temp1
	STS(adr_HYT939_TEMPERATUR_DATA_LSB),temp1
	STS(adr_HYT939_TEMPERATUR_DATA_MSB),temp2
	; BERECHNUNG					
	rjmp HYT939_BERECHNUNG
;-------------------------------------------------------------------------------
HYT939_MESSUNG_ERROR:
	STS(adr_HYT939_DATA_LSB),NULL
	STS(adr_HYT939_DATA_MSB),NULL
	STS(adr_HYT939_TEMPERATUR_DATA_LSB),NULL
	STS(adr_HYT939_TEMPERATUR_DATA_MSB),NULL
	STS(adr_HYT939_RH),NULL
	STS(adr_HYT939_TEMPERATUR_SIGNIERT),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_BERECHNUNG:
	; rF [%] = 100 * rFraw / 2^14												
;-------------------------------------------------------------------------------
	; TESTZAHL	3FFF:2=50%	
;	ldi temp1,LOW (16384/2)
;	ldi temp2,HIGH(16384/2)
	LDS temp1,(adr_HYT939_DATA_LSB); MULTIPLIKATION (99 x addieren)				
	LDS temp2,(adr_HYT939_DATA_MSB)
	clr temp3
	clr temp4
	mov R0,temp1
	mov R1,temp2
	ldi temp9,(100-1)
HYT939_BERECHNUNG_s1:
	add temp1,R0
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
	dec temp9
	brne HYT939_BERECHNUNG_s1
;-------------------------------------------------------------------------------
	subi temp1,BYTE1(-8192)			; aufrunden		
	sbci temp2,BYTE2(-8192)	
	sbci temp3,BYTE3(-8192)	
	sbci temp4,BYTE4(-8192)	
	ldi temp9,14				;  durch 2^14	
HYT939_BERECHNUNG_s2:
	LSR temp4
	ROR temp3
	ROR temp2
	ROR temp1
	dec temp9
	brne HYT939_BERECHNUNG_s2
	; rF>100 ?						
	cpi temp1,100+1
	brsh HYT939_BERECHNUNG_ERROR
	STS(adr_HYT939_RH),temp1					; Ergebnis			
;-------------------------------------------------------------------------------
	;T [C] = 165 / 2^14 * Traw - 40
	LDS temp1,(adr_HYT939_TEMPERATUR_DATA_LSB)
	LDS temp2,(adr_HYT939_TEMPERATUR_DATA_MSB)
	clr temp3
	clr temp4
	mov R0,temp1
	mov R1,temp2
	ldi temp9,(165-1)
HYT939_BERECHNUNG_s3:
	add temp1,R0
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
	dec temp9
	brne HYT939_BERECHNUNG_s3
;-------------------------------------------------------------------------------
	subi temp1,BYTE1(-8192)			; aufrunden		
	sbci temp2,BYTE2(-8192)	
	sbci temp3,BYTE3(-8192)	
	sbci temp4,BYTE4(-8192)	
	ldi temp9,14					;  durch 2^14	
HYT939_BERECHNUNG_s4:
	LSR temp4
	ROR temp3
	ROR temp2
	ROR temp1
	dec temp9
	brne HYT939_BERECHNUNG_s4
;-------------------------------------------------------------------------------
	subi temp1,LOW (40)							; Subtraktion		
	sbci temp2,HIGH(40)
	; T>100 ?						
	cpi temp1,100+1
	brsh HYT939_BERECHNUNG_ERROR
	STS(adr_HYT939_TEMPERATUR_SIGNIERT),temp1	; Ergebnis			
	ret
;-------------------------------------------------------------------------------
HYT939_BERECHNUNG_ERROR:
	STS(adr_HYT939_RH),NULL
	STS(adr_HYT939_TEMPERATUR_SIGNIERT),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




