;												
; HYGROMETER HYT939								
;												
; ATmega8-16  1 MHz								
;												
; Bernhard.Erfurt@gmx.de						
; 11/2015										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> s. Belegung							
; PB1 ==> s. Belegung							
; PB2 ==> TASTE									
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> s. Belegung							
; PB7 ==> s. Belegung							
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> TASTE									
; PC3 ==> TASTE									
; PC4 ==> SDA									
; PC5 ==> SCL									
;												
; PD0 ==> s. Belegung							
; PD1 ==> s. Belegung							
; PD2 ==> s. Belegung							
; PD3 ==> s. Belegung							
; PD4 ==> s. Belegung							
; PD5 ==> s. Belegung							
; PD6 ==> s. Belegung							
; PD7 ==> s. Belegung							
;												

;												
; ANZEIGE-PROGRAMMSTART:						
; "2015" - JAHR									
; "u  2" - VERSION								
; "21C" - Temperatur Sensor					
; "----" - EEPROM LOAD							
; "51 %" - Luftfeuchte							
;												

;												
; ANZEIGE-MENUE:								
; "51 %" - Luftfeuchte							
; "21C" - Temperatur Sensor					
; "HELL"  "   4" - Helligkeit					
; "SCH "  "  40" - Schwellwert					
; "SCL "  "5681" - TWI-TAKTFREQUENZ				
; "res " - RESET auf Werkseinstellung			
; "----" - EEPROM SAVE and EXIT					
;												

; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT					=1000000			
; VERSION										
.equ VERSION				=2

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						= SRAM_START+0			; 0x0060 START Adresse 		
.equ adr_MENUE						= SRAM_START+2
.equ adr_HELL_WERT					= SRAM_START+4
.equ adr_TASTE						= SRAM_START+10

.equ adr_HYT939_DATA_MSB			= SRAM_START+80
.equ adr_HYT939_DATA_LSB			= SRAM_START+81
.equ adr_HYT939_TEMPERATUR_DATA_MSB	= SRAM_START+82
.equ adr_HYT939_TEMPERATUR_DATA_LSB	= SRAM_START+83
.equ adr_HYT939_RH					= SRAM_START+84	; ERGEBNIS %			
.equ adr_HYT939_TEMPERATUR_SIGNIERT	= SRAM_START+85	; ERGEBNIS Temperatur	
.equ adr_HYT939_RH_SCHWELLE_L		= SRAM_START+86

.equ adr_LED_ZAEHLER				= SRAM_START+100
.equ adr_LED_BYTE_0					= SRAM_START+101; DIGIT (rechts)
.equ adr_LED_BYTE_1					= SRAM_START+102
.equ adr_LED_BYTE_2					= SRAM_START+103
.equ adr_LED_BYTE_3					= SRAM_START+104

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										
.def TWI_FEHLER_CODE	= R12
.def NULL 				= R14
.def EINS 				= R15

.def temp 				= R16
.def temp1 				= R17
.def temp2 				= R18
.def temp3 				= R19
.def temp4 				= R20
.def temp5 				= R21
.def temp6 				= R22
.def temp7 				= R23
.def temp8 				= R24
.def temp9 				= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0				

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI      ; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; SRAM clear										
	rcall SRAM_CLEAR
; PORT_CLEAR										
	rcall PORT_CLEAR
; REGISTER_CLEAR									
	rcall REGISTER_CLEAR
; SEGMENT7_INITIALISIERUNG							
	rcall SEGMENT7_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
; TASTATUR_INITIALISIERUNG							
	rcall TASTATUR_INITIALISIERUNG
; TWI_INITIALISIERUNG								
	rcall TWI_INITIALISIERUNG
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; HELLIGKEIT		
	ldi temp,4
	STS(adr_HELL_WERT),temp
	; SCHWELLWERT_L		
	ldi temp,40
	STS(adr_HYT939_RH_SCHWELLE_L),temp
; PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; ##############################################################################
; ##############################################################################
; ##############################################################################
; interrupts freigeben								
	SEI
	rcall ANZEIGE_LED_TEST
	rcall ANZEIGE_BEGRUESSUNG
	rcall WAIT_1s
	rcall ANZEIGE_VERSION
	rcall TASTATUR_WAIT
;	rcall TWI_BUS_CHECK
;	rcall TWI_SCAN
;	rcall WAIT_1s
	rcall HYT939_MESSUNG
	rcall HYT939_ANZEIGE_TEMPERATUR
	rcall TASTATUR_WAIT
	rcall EEPROM_KONFIGURATION_LADEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	
	rcall TASTATUR_ABFRAGE
	rcall MENUE
	rcall PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "LEDMASTER_TIMER.asm"
.include "LEDMASTER_SONSTIGES.asm"
.include "LEDMASTER_TWI_HYT939.asm"
.include "LEDMASTER_TWI_MASTER.asm"
.include "LEDMASTER_TASTEN.asm"
.include "LEDMASTER_MENUE.asm"
.include "LEDMASTER_ANZEIGE.asm"
.include "LEDMASTER_EEPROM.asm"
.include "LEDMASTER_7SEGMENT.asm"
.include "LEDMASTER_7SEGMENT_BELEGUNG_2015V2.asm"	; Gert schwarzes Gehuse mit Hygrometer und Thermometer
.include "LEDMASTER_WAIT_01MHZ.asm"


